{********************************************}
{* OpenSource Library                       *}
{*                                          *}
{* Author : Vitaly Checkryzhev              *}
{* E-Mail : virty1k@mail.ru                 *}
{* WWW    : http://www.str.ru/~virty        *}
{* WWW    : http://virtualsoft.narod.ru     *}
{* WWW    : http://chat.str.ru              *}
{*                                          *}
{*               All rights reserved, 2002  *}
{********************************************}

uses Math;
{$APPTYPE CONSOLE}

var
 MVals,                   //   
 Koeff,                   //  
 Powers,                  //  
 Vars : Array of Integer; //   
 EqVal,                   //   
 R    : Integer;          //   
 I,
 N : Word;

//     
function Root(X, Y: LongInt): Integer;
begin
 Root := Round(Exp(ln(X)/Y));
end;

{ -=        =- }

procedure WriteVar(Index: Word);
begin
 case Powers[Index] of
  1:   Write(Chr(65 + Index));
  else Write(Chr(65 + Index), '^', Powers[Index]);;
 end;
end;

procedure WriteResult;
var
 I: Word;
begin
 For I := Low(Vars) to High(Vars) do
  if Koeff[I]<>0 then
   Write(Chr(65 + I), ' = ', Vars[I]:5, '; ');
 Writeln;
 Inc(R);
end;

{ -= --- =-}

//  
function Solved: Boolean;
var
 I: Word;
 C: Extended;
begin
 C := 0;
 For I := Low(Vars) to High(Vars) do
  C := C + Koeff[I]*IntPower(Vars[I], Powers[I]);
 Solved := C = EqVal;
end;

//  
procedure CalcLevel(Index: Word);
var
 I: Integer;
begin
 if MVals[Index]>0 then
 For I := 0 to MVals[Index] do
 begin
  Vars[Index] := I;
  If Solved() then WriteResult();
  if Index>0  then CalcLevel(Index-1);
 end else if Index>0 then CalcLevel(Index-1);
end;

begin
 R := 0;  //  
 Writeln('Enter variable number:');
 Write('>');
 Readln(N); //  

 //   
 SetLength(MVals,  N);
 SetLength(Vars,   N);
 SetLength(Powers, N);
 SetLength(Koeff,  N);

 Writeln('Enter pairs: coeff power');
 For I := Low(Vars) to High(Vars) do
  begin
   Write('>');
   Read(Koeff[I], Powers[I]);
  end;
 Writeln('Enter equality result:');
 Write('>');
 Readln(eqVal);
 Writeln;

 //   
 For I := Low(Vars) to High(Vars) do
 begin
  case Sign(Koeff[I]) of
   NegativeValue :
    begin
     Write(' - ');
     If Abs(Koeff[I])<>1 then Write(Abs(Koeff[I]));
     WriteVar(I);
    end;
   PositiveValue :
    begin
     if I>Low(Vars) then Write(' + ');
     If Koeff[I]<>1 then Write(Koeff[I]);
     WriteVar(I);
    end;
  end;
 end;
 Writeln(' = ', EqVal, #13#10);

 //     
 For I := Low(Vars) to High(Vars) do
 begin
  if (Koeff[I]<>0) then
  begin
   if (Powers[I]<>0) then
     MVals[I] := Root(EqVal div Abs(Koeff[I]), Powers[I])
    else
   MVals[I] := EqVal div Koeff[I]
  end else MVals[I] := 0;
 end;

 //   
 Writeln('-====================-');
 CalcLevel(N-1);
 Writeln('-====================-');

 N := 1;
 For I := Low(Vars) to High(Vars) do
  if MVals[I]<>0 then
   N := N * MVals[I];
 Writeln('Roots: ', R, ', Iterations: ', N);
 Readln;
end.
